### 项目结构

- package.json 文件
    ```json
    {
        "scripts": {
            "eslint": "eslint ./src --color --fix",
            "w": "webpack --color --watch --env.NODE_ENV=dev --progress",
            "b": "webpack --color --env.NODE_ENV=dev --progress",
            "p": "webpack -p --color --env.NODE_ENV=prod --progress",
            "nodemon": "set NODE_ENV=dev&& nodemon src/server/index.js --config nodemonrc.json",
        },
        "dependencies": {
            "antd": "^2.13.3",
            "babel-plugin-import": "^1.4.0",
            "babel-plugin-transform-decorators-legacy": "^1.3.4",
            "babel-preset-react": "^6.24.1",
            "babel-preset-stage-0": "^6.24.1",
            "body-parser": "^1.17.2",
            "chai": "^4.1.2",
            "clean-webpack-plugin": "^0.1.16",
            "codemirror": "^5.31.0",
            "cross-env": "^5.0.5",
            "css-loader": "^0.28.4",
            "ejs": "^2.5.7",
            "extract-loader": "^0.1.0",
            "extract-text-webpack-plugin": "^3.0.0",
            "file-loader": "^0.11.2",
            "github": "^12.0.1",
            "history": "^4.6.3",
            "html-webpack-plugin": "^2.29.0",
            "http": "^0.0.0",
            "json-loader": "^0.5.7",
            "less": "^2.7.2",
            "less-loader": "^4.0.5",
            "lodash": "^4.17.4",
            "mobx": "^3.3.0",
            "mobx-react": "^4.3.2",
            "mocha": "^4.0.1",
            "moment-timezone": "^0.5.14",
            "mongodb": "^2.2.33",
            "mongoose": "^4.11.5",
            "path": "^0.12.7",
            "prismjs": "^1.8.3",
            "react": "^16.1.1",
            "react-dom": "^16.1.1",
            "react-router": "^4.2.0",
            "react-router-dom": "^4.2.2",
            "request-promise": "^4.2.2",
            "style-loader": "^0.18.2",
            "webpack": "^3.8.1",
            "webpack-manifest-plugin": "^1.3.1",
            "webpack-merge": "^4.1.0",
            "yarn": "^0.27.5"
        },
        "devDependencies": {
            "babel-core": "^6.25.0",
            "babel-loader": "^7.1.1",
            "babel-preset-env": "^1.6.0"
        }
    }
    ```
- 项目目录结构
    ```
    |-- undefined
        |-- .babelrc
        |-- .eslintrc.js
        |-- .gitignore
        |-- .npmrc
        |-- ecosystem.config.js
        |-- favicon.png
        |-- nodemonrc.json
        |-- package.json
        |-- README.md
        |-- webpack.config.js
        |-- assets
        |   |-- font
        |   |-- images
        |   |-- media
        |   |-- template
        |-- build
        |   |-- webpack.dev.config.js
        |   |-- webpack.prod.config.js
        |-- config
        |   |-- client.js
        |   |-- project.js
        |   |-- server.js
        |-- dist
        |   |-- index.html
        |-- src
        |   |-- client
        |   |   |-- index.jsx
        |   |   |-- common
        |   |   |   |-- commonStyle.less
        |   |   |-- components
        |   |   |   |-- Content.js
        |   |   |   |-- body.js
        |   |   |   |-- Header.js
        |   |   |   |-- Sider.js
        |   |   |-- features
        |   |   |   |-- Trigger.js
        |   |   |-- less
        |   |   |   |-- body.less
        |   |   |   |-- content.less
        |   |   |   |-- header.less
        |   |   |   |-- index.less
        |   |   |   |-- sider.less
        |   |   |-- store
        |   |       |-- index.js
        |   |-- server
        |       |-- index.js
        |-- test
            |-- demo.test.js

    ```

<!-- 
### 疑问
 - 目前来说，前端新鲜工具层出不穷，从less/css/study
   	![](http://img.blog.csdn.net/20170301214848077?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvbGl1aGFvbWF0b3U=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center)
    到底学习的方法。。
    1.看官方文档？
    2.看博客？
    二者所说的不一致？要怎么做？
    怎么看只看中文博客   求速成？

    less的学习
    http://www.css88.com/doc/less/usage/index.html#command-line-usage-installing-for-node-development-
    官方推荐编译器 -- lessc vs koala   ？？？
    具体项目中到底用哪一款？
    我认为要以官方文档为标准进行项目开发，
    1.用的人多，遇到bug网上搜也容易搜到
    2.有官方维护 -->